	list p=16f628a
	#include <P16f628a.INC>

	ERRORLEVEL      -302    	;EVITER LE MESSAGE D'ERREUR 302

	__CONFIG	_PWRTE_ON & _WDT_OFF & _XT_OSC & _BODEN_OFF & _LVP_OFF


toggel	Equ	0x20		; MAINTIEN DE LA BIT 0
gr	Equ	0x21		; PACKET DE 5 BIT POUR ADRESSAGE
co	Equ	0x22		; PACKET DE 6 BIT POUR COMMANDE
cycl_1	Equ	0x23		; HORLOGE
cycl_2	Equ	0x24		; HORLOGE

#define	IrOut	PORTA, 1

;****************************************************************************
	org 	0

Init
; INSTALLATION DES PORT
	bsf     STATUS, RP0	; Bank 1
	movlw	B'00111100'	; LA SORTIE EN RA1 
	movwf	TRISA		; 
	movlw	B'11110000'	; RB4  RB7 DIRECT EN ENTREE
	movwf	TRISB
	bcf     STATUS, RP0	; Bank 0
	clrf	PORTA		; 
	clrf	PORTB		;

; TOUT LES COMPARATEUR DE 16F628 EN MODE NUMERIQUE
	BSF	CMCON, CM0
	BSF	CMCON, CM1
	BSF	CMCON, CM2

; DETECTION DE L'INTERRUPTION DANS LES PORT DE RB4  RB7
	bsf     STATUS, RP0	; Bank 1
	bcf	OPTION_REG, 7	; COMPOSATION ON
	bcf     STATUS, RP0	; Bank 0
	clrf	INTCON		; GIE 0
	bsf	INTCON, RBIE	; RBIF ACTIVER

; COMPOSATION OFF
	bcf	INTCON, RBIF

Main
	sleep
	; EM MODE VEILLE JUSQU' LA DETECTION D'UNE INTERRUPTION DANS L'UN DES PORT RB4  RB7
	btfss	INTCON, RBIF
	goto	Main		; RETOUR  DEBUT
	movfw	PORTB
	bcf	INTCON, RBIF
    


	btfss	PORTB,4
	call	CMD1

    

	btfss	PORTB,5
	call	CMD2
  goto	Main




;****************************************************************************
CMD1 
    bsf     PORTA,0
	movlw	D'0'		; TV
	movwf	gr
	movlw	D'2'		; TOUCHE 2 DE TC
	movwf	co
	call	Tx
    bcf PORTA,0
	return
CMD2
    bsf     PORTA,0
	movlw	D'0'		; TV
	movwf	gr
	movlw	D'3'		; TOUCHE 1 DE TC
	movwf	co
	call	Tx
    bcf PORTA,0
	return

;****************************************************************************
;MACRO DE TRANSMISSION

Tx
	incf	toggel, f

	;BIT DE DEPART
	call	TxUn

	;inverTION DE  C6
	btfss	co,6		;1T
	call	TxUn		;2T+
	btfsc	co,6		;2T
	call	TxZero		;0T

	;Toggelbit
	btfsc	toggel,0
	call	TxUn
	btfss	toggel,0
	call	TxZero

	;A4,3,2,1,0
	btfsc	gr,4
	call	TxUn
	btfss	gr,4
	call	TxZero

	btfsc	gr,3
	call	TxUn
	btfss	gr,3
	call	TxZero

	btfsc	gr,2
	call	TxUn
	btfss	gr,2
	call	TxZero

	btfsc	gr,1
	call	TxUn
	btfss	gr,1
	call	TxZero

	btfsc	gr,0
	call	TxUn
	btfss	gr,0
	call	TxZero

	;C5,4,3,2,1,0
	
	btfsc	co,5
	call	TxUn
	btfss	co,5
	call	TxZero

	btfsc	co,4
	call	TxUn
	btfss	co,4
	call	TxZero

	btfsc	co,3
	call	TxUn
	btfss	co,3
	call	TxZero

	btfsc	co,2
	call	TxUn
	btfss	co,2
	call	TxZero

	btfsc	co,1
	call	TxUn
	btfss	co,1
	call	TxZero

	btfsc	co,0
	call	TxUn
	btfss	co,0
	call	TxZero

	return

;****************************************************************************
; TRANSMISSION DE  0(on-off)
TxZero
	call	LichtAn		;2T
	call	LichtAus	;2T
	return			;2T

;****************************************************************************
; TRANSMISSION DE  1 (off-on)	
TxUn
	call	LichtAus
	call	LichtAn
	return

;****************************************************************************
; 889us 
LichtAus

	movlw	D'175'
	movwf	cycl_2
LichtAus2
	nop			;1T
	nop			;1T
	decfsz	cycl_2,f	;1T
	goto	LichtAus2	;2T
	return			;2T


LichtAn
	; 1. Puls
	bsf	IrOut
	movlw	
	movwf	cycl_1
	nop
	nop
	nop
	nop
	bcf	IrOut

	
LichtAn1
	;Pause
	movlw	D'5'		;1T
	movwf	cycl_2		;1T
	nop			;1T
	nop			;1T
LichtAn2			; 4x3T + 1x2T =14T
	decfsz	cycl_2,f	;1T
	goto	LichtAn2	;2T
	;Puls			;7T
	bsf	IrOut
	nop
	nop
	nop
	nop
	nop
	nop
	bcf	IrOut
	decfsz	cycl_1,f	;1T
	goto	LichtAn1	;2T

	return

	end





