;((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((
;		
;		PIC 16F628
; 		Reception de code RC5 + LCD 4x16* (ou plus)+ 6 sorties (leds)
; 		ryl le 06/01/2005 23:46
;		
;))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
	
	LIST	 p=16f628a
	#include <p16f628a.inc>											
	__CONFIG	_BODEN_OFF  & _PWRTE_OFF & _WDT_OFF & _LVP_OFF & _MCLRE_ON & _XT_OSC
	
	; Do not show warnings										
	ERRORLEVEL      -302
		cblock 0x20
donn1	:	1			; reception des bits RC5 
donn2	:	1			; reception des bits RC5		
		
BUSY_1:		1			;var utilise pour temporisation
NB_TEMPO:	1			;var utilise pour temporisation
cmpt1:		1			;var utilise pour temporisation

RC5_CTRL:	1			;var bit controle RC5
RC5_ADR:	1			;var bits adresse RC5
RC5_DATA:	1			;var bits donnes RC5
Loop1:		1			;compteur
Loop2:		1
Loop3:		1
		endc
	ORG	0x0000	
	
		
	bsf	STATUS	,RP0		
	MOVLW B'00110000'	
    MOVWF TRISA
	MOVLW B'00010000'
    MOVWF TRISB
    bcf STATUS, RP0
    bcf	INTCON, GIE	; disable Interupt
    clrf PORTA
    clrf PORTB
boucl_prog
	
	call	Recv_RC5			; Rcption d'un code RC5
	
	
	movfw	RC5_DATA		; si RC5_DATA =0 (touche N0 de la TC) 
	btfsc	STATUS,Z		; 
	goto    Action_1	;
	xorlw	(0x01 ^ 0x00)		; si RC5_DATA =1 (touche N1 de la TC)
	btfsc	STATUS,Z		;
	goto    Action_2	;			
	goto	fini			;

Action_1    bsf PORTA,2
			bsf	PORTA,0			; mettre a 1 la broche RB0 (led n1)
			
Action_2
			bsf	PORTA,3
            bsf PORTA,1			; mettre a 1 la broche RB1 (led n2)

		
fini	
		call	tempox		; tempo entre chaque detection/affichage
		call	tempox		;   
	
	goto boucl_prog			; recommencer la detection RC5+LCD
		
busy		movwf	NB_TEMPO		; Temporisation : dure 500s x "la valeur contenue dans W"
boucle		movlw	.123
		movwf	BUSY_1
boucle1		NOP
		decfsz	BUSY_1,1
		goto	boucle1
		decfsz	NB_TEMPO,1
		goto	boucle	
		return   			; retour de la sous-routine
tempox   	movlw 0x0B 			; pour x boucles 
tempoxx		movwf cmpt1 			; dans cmpt1 
boucle2         movlw	0x25
		call 	busy         		; TEMPO xxxx S
    		decfsz cmpt1 , f  		; si 0, dcrmenter compteur 3 
   		goto boucle2 			; si cmpt1 pas 0, recommencer boucle2 
   		return    			; retour de la sous-routine 
Recv_RC5 	
		btfsc	PORTB, 4	; Attendre un "0" 
		goto	Recv_RC5	; du bit de start

		call	Tempo444	; attendre 444us, 1/4 cycle pour capture bit a bit
		
		btfsc	PORTB, 4	; tester si "0" (anormal probabl... une emission en cours mal sync!)
		goto	Fin_RC5		; ERREUR ! finir la phase de reception

		clrf	donn1		; donn1=0
		clrf	donn2		; donn2=0
		movlw	.13		; 13 bits a capturer
		movwf	Loop3		; 12 sont traites 

		call	Tempo888	; 1/4 du 2' Bit		
	
nextbit         rlf	donn1,f		; rotation a gauche de tous les bits
		rlf	donn2,f		;
		bcf	donn1, 0	; forcer a "0" le bit0 de "donn1" 
		btfsc	PORTB, 4	; si RB6 (infra rouge) =0
		bsf	donn1, 0	; forcer a "1" le bit0 de "donn1"

		call	Set_bit		; attendre flanc montant ou desc en fonction de l'etat de RB6 (infra rouge)

		call	Tempo444	; attendre 3/4 de Bit pour se 				;tempo	; = 444,5 us
		call	Tempo888	; placer a 1/4 du bit suivant				;tempo	; = 889 us
		decfsz	Loop3,f		; les 13 bits sont t-ils tous reus
		goto	nextbit		; si non, recommencer reception du bit suivant

		movfw	donn1			; recuperation des 6 bits de Donnes RC5
		andlw	b'00111111'		; 0 sur les bits non utiliss
		movwf	RC5_DATA		; Placer val dans "RC5_DATA"

		rlf	donn1,f			; decalage a gauche de 2 
		rlf	donn2,f			; pour faire "remonter" les bits	
		rlf	donn1,f			; de l'Adresse RC5 
		rlf	donn2,f			; de donn1
		movfw	donn2			; vers donn2
		andlw	b'00011111'		; 0 sur les bits non utiliss
		movwf	RC5_ADR			; recuperation des 5 bits dans "RC5_ADR"
	
		clrf	RC5_CTRL		; recuperation du bit 	
		btfss	donn2, 5		; de controle RC5
		bsf	RC5_CTRL, 0		; dans "RC5_CTRL"
Fin_RC5
		return
		

Set_bit 	movlw	0x09		; Tempo
		movwf	Loop1
tim11 		movlw	0x20		;
		movwf	Loop2
tim22 		decfsz	Loop2,f	
		goto	tim22

		btfsc	PORTB, 4	; si "0"
		goto	haut
bas		btfsc	donn1, 0	; bit en cours =0 ?	
		return			; flanc haut/bas	
		goto	saut_l
haut		btfss	donn1, 0	; bit en cours =1 ?	
		return			; flanc bas/haut			
saut_l		decfsz	Loop1,f	
		goto	tim11	
		return			
		

Tempo888	movlw	0x12		; Temporisation de 888s
		goto	tim0
		
Tempo444	movlw	0x09		; Temporisation de 444s
tim0 		movwf	Loop1
tim1 		movlw	0x0F
		movwf	Loop2
tim2 		decfsz	Loop2,f	
		goto	tim2

		decfsz	Loop1,f	
		goto	tim1	

	return
	end
